/**
 * Mètode per saber si el primer coeficient no nul del polinomi és de el de grau 1
 * @param  valorstaulell: és la variable que conté els coeficients del polinomi
 * @return true en cas que no hi hagi termes de segon grau i false en cas contrari
 */
function primernonulx(valorstaulell){
  if (valorstaulell[0]==0 && valorstaulell[1]==0) return true;
  return false; 
}


/** Mètode que ens diu si dos arrays són iguals.
 *  @param valorsenunciat: array amb els coeficients d'un polinomi
 *  @param valorssolucio: array amb els coeficients de l'altre polinomi
 *  @return true en cas que enunciat sigui igual a solució, false en cas contrari
 */
function soniguals(valorsenunciat, valorssolucio){
  for (i=0;i<valorssolucio.length;i++){
    if (valorsenunciat[i]!= valorssolucio[i]){
      return false;
    }
  }
  return true; 
}

/** Mètode que genera un nou exercici de reducció de termes semblants, 
 * l'atzar genera els coeficients dels dos polinomis, 
 * no es dóna per bo l'exercici si el polinomi generat ja està reduït
 * el nou exercici s'escriu a la barra d'enunciat,
 * a la barra de pas s'hi escriu pas 1
 *  @param valorsenunciat: array amb els coeficients del polinomi enunciat
 *  @param difficulty: dificultat de l'exercici (alta, mitjan, baixa)
 *  @return valorssolucio: array amb els coeficients del polinomi solució
 *  @return pas: s'actualitza a pas 1
 */
function nouexercici(valorsenunciat,valorssolucio,pas,difficulty){
  pas=0;
  
  do{ 
  switch (difficulty) {
    case "alta":
       do{
        for (i=0;i<6;i++){
          rand = Math.floor((Math.random()*3));
          valorsenunciat[i]=rand;
        }
      } while (valorsenunciat[0]==0 && valorsenunciat[1]==0);  
       break;
    case "mitjana":
        do{
          for (i=2;i<6;i++){
            rand = Math.floor((Math.random()*3));
            valorsenunciat[i]=rand;
          }
        } while (valorsenunciat[2]==0 && valorsenunciat[3]==0);  
        break;
    case "baixa":
        for (i=4;i<6;i++){
          rand = Math.floor((Math.random()*3));
          valorsenunciat[i]=rand+1;
       }
       break;
  }
  solucio(valorsenunciat,valorssolucio);
  } while (soniguals(valorsenunciat, valorssolucio));
  
  var lloc="enunciat";
  $('div[id='+lloc+']').html("");
  escriupolinomi(lloc,valorsenunciat);
  $("#barrapas").html("Pas 1: Construeix el model");
}

/** Mètode que genera els coeficients del polinomi solució,
 * agafa coeficients de segon grau i els suma o resta segons quin sigui el més gran, 
 * el mateix amb els coeficients de primer grau i el termes independents 
 *  @param valorsenunciat: array amb els coeficients del polinomi enunciat
 *  @return valorssolucio: array amb els coeficients del polinomi solució
 */
function solucio(valorsenunciat, valorssolucio){
  if (valorsenunciat[0]>valorsenunciat[1]){
    valorssolucio[0]=valorsenunciat[0]-valorsenunciat[1];
    valorssolucio[1]=0;
  }else if (valorsenunciat[0]<valorsenunciat[1]){
    valorssolucio[1]=valorsenunciat[1]-valorsenunciat[0];
    valorssolucio[0]=0;
  }else if (valorsenunciat[0]==valorsenunciat[1]) {
    valorssolucio[0]=0;
    valorssolucio[1]=0;
  }
      
   if (valorsenunciat[2]>valorsenunciat[3]){
    valorssolucio[2]=valorsenunciat[2]-valorsenunciat[3];
    valorssolucio[3]=0;
  }else if (valorsenunciat[2]<valorsenunciat[3]){
    valorssolucio[3]=valorsenunciat[3]-valorsenunciat[2];
    valorssolucio[2]=0;
  }else if (valorsenunciat[2]==valorsenunciat[3]){
    valorssolucio[2]=0;
    valorssolucio[3]=0;
  }
      
   if (valorsenunciat[4]>valorsenunciat[5]){
    valorssolucio[4]=valorsenunciat[4]-valorsenunciat[5];
    valorssolucio[5]=0;
  }else if (valorsenunciat[4]<valorsenunciat[5]){
    valorssolucio[5]=valorsenunciat[5]-valorsenunciat[4];
    valorssolucio[4]=0;
  }else if (valorsenunciat[4]==valorsenunciat[5]){
    valorssolucio[4]=0;
    valorssolucio[5]=0;
  }
}

/** Mètode que escriu, al div corresponent,un polinomi a partir dels seus coeficients, 
 * caldrà afegir els signes als coeficients i la part literal (x^2 o x),
 * es fa una crida al mètode primernonulx pels casos en què el polinomi 
 * sigui de primer grau que no s'escrigui el signe + inicial,
 * és a dir, no volem +ax sinó ax pel terme lineal
 *  @param valorstaulell: array amb els coeficients del polinomi a escriure
 *  @param lloc: nom del div on s'escriurà polinomi (div enunciat o div resolucio)
 */
function escriupolinomi(lloc,valorstaulell){
   var signes=['' ,'-','+','-','+','-'];
   var tiles=['x','x','x','x','',''];
    
   if(primernonulx(valorstaulell)){
    signes=['' ,'-','','-','+','-'];
    }
  
           
    for (i=0;i<2;i++){
    if(valorstaulell[i]==1){
                  $('div[id='+lloc+']').append(signes[i]+' '+tiles[i]+'<sup><small>'+"2"+'</small></sup>'+' ');
        } else if (valorstaulell[i]>0){
                      $('div[id='+lloc+']').append(signes[i]+' '+ valorstaulell[i]+ tiles[i]+'<sup><small>'+"2"+'</small></sup>'+' ');
                    }
        
        }
     for (i=2;i<4;i++){
    if(valorstaulell[i]==1){
                  $('div[id='+lloc+']').append(signes[i]+' '+ tiles[i]+" ");
        } else if (valorstaulell[i]>0){
                      $('div[id='+lloc+']').append(signes[i]+' '+valorstaulell[i]+ tiles[i]+" ");
                    }
        
        }
     
     for (i=4;i<6;i++){ 
           if (valorstaulell[i]>0){
            $('div[id='+lloc+']').append(signes[i]+' '+ valorstaulell[i]+' ');
         }
       }   
}

/** Mètode que actualitza l'array comptador d'exercicis iniciats,
 *  @param iniciats: array que conté el nombre d'exercicis iniciats de cada dificultat
 *  @param difficulty: dificultat de l'exercici iniciat (alta, mitjana, baixa)
 */
function actualitzainiciats(iniciats,difficulty){
  switch(difficulty){
    case "alta":
        iniciats[0]=iniciats[0]+1;
        break;
    case "mitjana":
        iniciats[1]=iniciats[1]+1;
        break;
    case "baixa":
        iniciats[2]=iniciats[2]+1;  
        break;
  }
}

/** Mètode que actualitza l'array comptador d'exercicis acabats de fer
 *  @param benfets: array que conté el nombre d'exercicis acabats de cada dificultat
 *  @param difficulty: dificultat de l'exercici iniciat (alta, mitjana, baixa)
 */
function actualitzabenfets(benfets,difficulty){
  switch(difficulty){
    case "alta":
        benfets[0]=benfets[0]+1;
        break;
    case "mitjana":
        benfets[1]=benfets[1]+1;
        break;
    case "baixa":
        benfets[2]=benfets[2]+1;  
        break;
  }
}

/** Mètode que comprova si el pas 1 (en programació pas=0)s'ha completat,
 * per fer-ho mira si els valorstaulell coincideix
 * amb els valors del coeficients del polinomi enunciat
 *  @param valorstaulell: coeficients dels polinomi
 *  @return true en cas que el pas1 s'hagi completat i false en cas contrari
 */
function verificapaszero(valorstaulell, valorsenunciat){
  if (soniguals(valorstaulell,valorsenunciat)){
      return true;
  }else{
     return false;
  }
}

/** Mètode que comprova si el pas 2 (en programació pas=1)s'ha completat,
 * per fer-ho mira si els valors dels comptadors de rajoles del taulell
 * coincideix amb els valors del coeficients del polinomi solució
 *  @param valorstaulell: coeficients del polinomi
 *  @return true en cas que el pas 2 s'hagi completat i false en cas contrari
 */
function verificapasu(valorstaulell,valorssolucio){
  if (soniguals(valorstaulell,valorssolucio)){
      return true;
  }else{
     return false;
  }
}

/** Mètode s'encarrega d'afegir al div resum, el resum de la feina feta,
 * ens informa de quants exercicis de cada dificultat s'han resolt correctament 
 * del total d'exercicis d'aquella dificultat iniciats
 *  @param iniciats: array que conté el nombre d'exercicis iniciats de cada dificultat
 *  @param benfets: array que conté el nombre d'exercicis completats de cada dificultat
 */
function missatgeresum(iniciats,benfets){
  $("div[id='resum']").html("");
  $("div[id='resum']").append(benfets[0]+ " de "+iniciats[0]+" exercicis de dificultat alta (grau 2), <br>" +
                                  benfets[1]+ " de "+iniciats[1]+" exercicis de dificultat mitjana (grau 1), <br>"+

                                benfets[2]+ " de "+iniciats[2]+" exercicis de dificultat baixa (grau 0). <br><br>"+
                                  "per seguir practicant tens tres opcions:<br>"+
                                  "- Clica a Nou i l'app et generarà un nou exercici de la mateixa dificultat.<br>"+
                                  "- Escull dificultat i l'app et generarà exercici de la dificultat escollida. <br>"+
                                  "- Clica Entra i podràs entrar tu mateix l'exercici.");                   
}


/** Mètode cridat quan és l'usuari que entra l'exercici a resoldre,
 * identifica la dificultat de l'exercici entrat i fa canviar l'opció de menú select, 
 * alta si és de 2n grau, mitjana si és de 1r grau i baixa si és de grau 0
 *  @param valorsenunciat: array amb els coeficients del polinomi enunciat
 */
function identifica_dificultat(valorsenunciat){

  if ((valorsenunciat[0]>0)|| (valorsenunciat[1]>0)){
    document.getElementById("select-dificultat").value="alta";
  }else if ((valorsenunciat[2]>0)|| (valorsenunciat[3]>0)){
    document.getElementById("select-dificultat").value="mitjana";
  }else{
    document.getElementById("select-dificultat").value="baixa";
  }
  $("#select-dificultat").selectmenu("refresh");
}

function valorscorrectes(valorsenunciat){
  switch (valorsenunciat.length){
    case 6:
      for (i=0;i<6;i++){
        if ((valorsenunciat[i]>3) || (valorsenunciat[i]<0)){
        return false;
        }
      }
      break;
    case 4:
      for (i=0;i<4;i++){
        if ((valorsenunciat[i]>3) || (valorsenunciat[i]<-3)){
      return false;
        }
      }
      break;
  } 
  return true; 
}

/** en carregar la pàgina Simplificar es crida al mètode mltiplicar()
 */
$(document).on('pageshow','#multiplicaralt',function(){
   multiplicar();
});

/** en carregar la pàgina Simplificar es crida al mètode simplificarexpressions()
 */
$(document).on('pageshow','#simplificaralt',function(){
   simplificarexpressions();
});

/**--------SIMPLIFICAR-------------- */
/** Mètode que conté tot el desenvolupament dinàmic de l'aplicació simplificar 
 */
function simplificarexpressions(){
  var valorstaulell=[0,0,0,0,0,0];
  var valorsenunciat=[0,0,0,0,0,0];
  var valorssolucio=[0,0,0,0,0,0];
  var pas; var difficulty;
  var benfets=[0,0,0];
  var iniciats=[0,0,0];
  pas=0;
  $("#enunciat").html("");
  $("#resolucio").html("");
  difficulty=$("#select-dificultat").val();
    
  $("#comencem").popup("open");    
         
  /** fem que les rajoles de div stock es puguin arrossegar */
  $( ".stock" ).draggable({
    helper: "clone",
    stop:function(ev, ui) {
      $(this).draggable('option','revert','invalid');
    }                
  });
                       
  /** fem que el taulell accepti rajoles de div stock o bé del mateix div taulell */
  $( "#droppable" ).droppable({
    accept: ".stock" || ".taulell",
    tolerance:"fit",
    drop: function (event, ui) {
      ui.draggable.clone().appendTo(this).css({ position: "absolute", top: ui.position.top, left: ui.position.left }).removeClass("stock").addClass("taulell").draggable() ;
      $(".taulell").draggable("option","containment","#droppable");
                   
      /** fem que cada cop que arrosseguem una rajola al taulell 
      * s'actualitzin els valorstaulell 
      */
      var id = ui.draggable.attr("id");
      switch (id){
        case "xqdiv":
          if (ui.draggable.hasClass("positiva")){
            valorstaulell[0]++ ;
            } else{
            valorstaulell[1]++ ;
            }
          break;
        case "xdiv":
          if (ui.draggable.hasClass("positiva")){
            valorstaulell[2]++ ;
            } else {
            valorstaulell[3]++ ;
            }
          break;
        case "udiv":
          if (ui.draggable.hasClass("positiva")){
            valorstaulell[4]++ ;
            } else {
            valorstaulell[5]++ ;
            } 
          break;
        }
        /** cal actualitzar div resolucio
        * que és on s'escriu polinomi representat al taulell 
        */
        var lloc="resolucio";
        $('div[id='+lloc+']').html("");
        escriupolinomi(lloc,valorstaulell);
        /**si s'ha completat correctament pas 1, un popup ens ho dirà i passarem al 2,
         en la programació pas=1 */
        if ((pas==0) && (verificapaszero(valorstaulell,valorsenunciat))){
          /*setTimeout('alert("Correcte, vés al pas següent!")', 500);*/
          $("#fipas1").popup("open");
          $("#barrapas").html("Pas 2: Redueix termes semblants");
          pas=pas+1;
        }
        
        /**fem que rajoles del taulell també siguin droppable, per poder eliminar
        * parelles zero, valorstaulell corresponents seran actualitzats  
        */
        $(".taulell").droppable({
          accept: ".taulell",
          drop: function (event, ui) {
            var iddivdra = ui.draggable.attr("id");
            var iddivdro = $(this).attr("id");
            if (iddivdra==iddivdro){
              if (($(this).hasClass("negativa") && ui.draggable.hasClass("positiva")) || ($(this).hasClass("positiva") && ui.draggable.hasClass("negativa"))){
                $(this).fadeOut();
                ui.draggable.fadeOut();
                switch (iddivdra){
                  case "udiv":
                    valorstaulell[4]-- ;
                    valorstaulell[5]-- ;
                    break;
                  case "xdiv":
                    valorstaulell[2]-- ;
                    valorstaulell[3]-- ;
                    break;          
                  case "xqdiv":
                    valorstaulell[0]-- ;
                    valorstaulell[1]-- ;
                    break;
                } //fi switch
              /** actualitzem div resolucio */
              var lloc="resolucio";
              $('div[id='+lloc+']').html("");
              escriupolinomi(lloc,valorstaulell);
              /** verifiquem pas 2 (en programació pas és l'1)
               * si s'ha resolt l'exercici un popup informarà a l'usuari */
              if ((pas==1) && (verificapasu(valorstaulell,valorssolucio))){
                $("#barrapas").html("Molt bé");
                actualitzabenfets(benfets,difficulty);
                $("#fipas2").popup("open");
                missatgeresum(iniciats,benfets);
                //setTimeout(explode1, 500);
              }
              } // if divs de signes oposats
            } // fi if si són divs iguals
          } //fi drop taullell
        }); //fi droppable taulell
      }  //fi drop droppable
    }); //fi droppable droppable
  
  /** fem que el div que conté la paperera sigui droppable
   * quan s'hi arrosseguin rajoles s'acualitzaren valorstaulell del taulell */
  $("#prova").droppable({
    accept: ".taulell",
    over: function(){
      $("#tapa").animate({
        top: "-=10"}).animate({
        top:"+=10"});
      },
    drop: function (event,ui){
      var iddra = ui.draggable.attr("id");
      ui.draggable.fadeOut();
      switch (iddra){
        case "udiv":
          if (ui.draggable.hasClass("positiva")){
            valorstaulell[4]-- ;
          } else  {
            valorstaulell[5]-- ;
          }
          break;
        case "xdiv":
          if (ui.draggable.hasClass("positiva")){
            valorstaulell[2]-- ;
          } else  {
            valorstaulell[3]-- ;
          }
          break;
        case "xqdiv":
          if (ui.draggable.hasClass("positiva")){
            valorstaulell[0]-- ;
            } else {
            valorstaulell[1]-- ;
          }
          break;
      }                                      
      /** també cal actualitzar div resolucio i verificar si tenim ja la solució */
      var lloc="resolucio";
      $('div[id='+lloc+']').html("");
      escriupolinomi(lloc,valorstaulell);
      if ((pas==0) && (verificapaszero(valorstaulell,valorsenunciat))){
          /*setTimeout('alert("Correcte, vés al pas següent!")', 500);*/
          $("#fipas1").popup("open");
          $("#barrapas").html("Pas 2: Redueix termes semblants");
          pas=pas+1;
        }
      if ((pas==1) && (verificapasu(valorstaulell,valorssolucio))){
          $("#barrapas").html("Molt bé");
          actualitzabenfets(benfets,difficulty);
          $("#fipas2").popup("open");
          missatgeresum(iniciats,benfets);
          //setTimeout(explode1, 500);
      } 
    } //fi drop
  });

/** cada vegada que usuari canviï la dificultat es generarà un nou exercici d'aquella dificultat */
$("#select-dificultat").change(function(event){
    difficulty = $(this).val();
    $(".taulell").fadeOut();
    $("#resolucio").html("");
    $("#barrapas").html("Pas 1: Construeix el model");
    pas=0;
    valorstaulell=[0,0,0,0,0,0];
    valorsenunciat=[0,0,0,0,0,0];
    valorssolucio=[0,0,0,0,0,0];
    nouexercici(valorsenunciat,valorssolucio,pas,difficulty);
    actualitzainiciats(iniciats,difficulty); 
});

/**quan es cliqui Esborrar, totes les rajoles del taulell s'esborraran
  * s'actualitzarà la barra de resolució 
  **/ 
 $( "#esborrar" ).click(function(){
 
  $(".taulell").fadeOut();
  $("#resolucio").html("");
  $("#barrapas").html("Pas 1: Construeix el model");
  pas=0;
  valorstaulell=[0,0,0,0,0,0]; 
  escriupolinomi("resolucio",valorstaulell); 
});

/** quan es cliqui Nou, es generarà un nou exercici de la dificultat que estigui seleccionada,
 * s'actualizarà el comptador d'exercicis iniciats */
$("#nouexercici").click(function(){
  if (difficulty=="") {
    $("#nocomencem").popup("open"); 
  } else {  
    $(".taulell").fadeOut();
    $("#resolucio").html("");
    $("#barrapas").html("Pas 1: Construeix el model");
    pas=0;
    valorstaulell=[0,0,0,0,0,0];
    valorsenunciat=[0,0,0,0,0,0];
    valorssolucio=[0,0,0,0,0,0];
    nouexercici(valorsenunciat,valorssolucio,pas,difficulty);
    actualitzainiciats(iniciats,difficulty); 
  }
  });


/** tancament dels popups informatius */
$("#acord").click(function(){
 $("#comencem").popup("close"); 
});

$("#acord1").click(function(){
 $("#nocomencem").popup("close"); 
});

$("#entesos1").click(function(){
$("#fipas1").popup("close");
});

$("#entesos2").click(function(){
$("#fipas2").popup("close");
});

/**els valors entrats per l'usuari en Entrar un exercici queden emmagatzemats com 
 * a valorsenunciat sempre i quan el polinomi entrat no estigui ja reduït,
 * es crida a identificar dificultat, i tot s'actualitza (barra enunciat, barra pas, 
 * *barra resolució, taulell buit)  */


/** Amb Ordenar les rajoles es reoordenen sobre el taulell segons el seu tipus,
* com que les dibuixem de nou sobre el taulell cal després afegir-los el droppable 
* i programar perquè puguin formar parelles zero*/
$("#ordenar").click(function(){
  $(".taulell").fadeOut();
 
  for (i=0;i<valorstaulell[4];i++){
      var div = $("#udiv").clone().css({float:'left',margin:'2px',
        backgroundColor:'yellow',borderBottomColor:'#ffd700',
        borderLeftColor:'#ffd700',borderRightColor:'#ffd700',
        borderTopColor:'#ffd700'}).removeClass().addClass("taulell").addClass("positiva").draggable() ;
      div.html("1");
      $("#droppable").append(div);
  }
    
  for (i=0;i<valorstaulell[5];i++){
    if (i==0){
      var div = $("#udiv").clone().css({clear:'left',float:'left',margin:'2px',
      backgroundColor:'red',borderBottomColor:'#dc143c',
      borderLeftColor:'#dc143c',borderRightColor:'#dc143c',
      borderTopColor:'#dc143c'}).removeClass().addClass("taulell negativa").draggable() ;
     div.html("-1");
    $("#droppable").append(div);
  }else{
    var div = $("#udiv").clone().css({float:'left',margin:'2px',
      backgroundColor:'red',borderBottomColor:'#dc143c',
      borderLeftColor:'#dc143c',borderRightColor:'#dc143c',
      borderTopColor:'#dc143c'}).removeClass().addClass("taulell negativa").draggable() ;
     div.html("-1");
    $("#droppable").append(div);
  }
  }
  for (i=0;i<valorstaulell[2];i++){
    if(i==0){
      var div = $("#xdiv").clone().css({clear:'left',float:'left',margin:'2px',
      backgroundColor:'#32dc32',borderBottomColor:'#228b22',
      borderLeftColor:'#228b22',borderRightColor:'#228b22',
      borderTopColor:'#228b22'}).removeClass().addClass("taulell positiva").draggable() ;
     div.html("x");
    $("#droppable").append(div);
   }else{
    var div = $("#xdiv").clone().css({float:'left',margin:'2px',
      backgroundColor:'#32dc32',borderBottomColor:'#228b22',
      borderLeftColor:'#228b22',borderRightColor:'#228b22',
      borderTopColor:'#228b22'}).removeClass().addClass("taulell positiva").draggable() ;
     div.html("x");
    $("#droppable").append(div);
  }
  }
  for (i=0;i<valorstaulell[3];i++){
    if(i==0){
      var div = $("#xdiv").clone().css({clear:'left',float:'left',margin:'2px',
      backgroundColor:'red',borderBottomColor:'#dc143c',
      borderLeftColor:'#dc143c',borderRightColor:'#dc143c',
      borderTopColor:'#dc143c'}).removeClass().addClass("taulell negativa").draggable() ;
     div.html("-x");
    $("#droppable").append(div);
  }else{
    var div = $("#xdiv").clone().css({float:'left',margin:'2px',
      backgroundColor:'red',borderBottomColor:'#dc143c',
      borderLeftColor:'#dc143c',borderRightColor:'#dc143c',
      borderTopColor:'#dc143c'}).removeClass().addClass("taulell negativa").draggable() ;
     div.html("-x");
    $("#droppable").append(div);
  }
  }
  for (i=0;i<valorstaulell[0];i++){
    if(i==0){
      var div = $("#xqdiv").clone().css({clear:'left',float:'left',margin:'2px',
      backgroundColor:'#0000cd',borderBottomColor:'#000080',
      borderLeftColor:'#000080',borderRightColor:'#000080',
      borderTopColor:'#000080'}).removeClass().addClass("taulell positiva").draggable() ;
    div.html("x"+'<sup><small>'+"2"+'</small></sup>');
    $("#droppable").append(div);
  }else{
    var div = $("#xqdiv").clone().css({float:'left',margin:'2px',
      backgroundColor:'#0000cd',borderBottomColor:'#000080',
      borderLeftColor:'#000080',borderRightColor:'#000080',
      borderTopColor:'#000080'}).removeClass().addClass("taulell positiva").draggable() ;
    div.html("x"+'<sup><small>'+"2"+'</small></sup>');
    $("#droppable").append(div);
  }
  }
  for (i=0;i<valorstaulell[1];i++){
    if(i==0){
      var div = $("#xqdiv").clone().css({clear:'left',float:'left',margin:'2px',
      backgroundColor:'red',borderBottomColor:'#dc143c',
      borderLeftColor:'#dc143c',borderRightColor:'#dc143c',
      borderTopColor:'#dc143c'}).removeClass().addClass("taulell negativa").draggable() ;
     div.html("-x"+'<sup><small>'+"2"+'</small></sup>');
    $("#droppable").append(div);
  }else{
    var div = $("#xqdiv").clone().css({float:'left',margin:'2px',
      backgroundColor:'red',borderBottomColor:'#dc143c',
      borderLeftColor:'#dc143c',borderRightColor:'#dc143c',
      borderTopColor:'#dc143c'}).removeClass().addClass("taulell negativa").draggable() ;
     div.html("-x"+'<sup><small>'+"2"+'</small></sup>');
    $("#droppable").append(div);
  }
  }
  $(".taulell").droppable({
          accept: ".taulell",
          drop: function (event, ui) {
            var iddivdra = ui.draggable.attr("id");
            var iddivdro = $(this).attr("id");
            if (iddivdra==iddivdro){
              if (($(this).hasClass("negativa") && ui.draggable.hasClass("positiva")) || ($(this).hasClass("positiva") && ui.draggable.hasClass("negativa"))){
                $(this).fadeOut();
                ui.draggable.fadeOut();
                switch (iddivdra){
                  case "udiv":
                    valorstaulell[4]-- ;
                    valorstaulell[5]-- ;
                    break;
                  case "xdiv":
                    valorstaulell[2]-- ;
                    valorstaulell[3]-- ;
                    break;          
                  case "xqdiv":
                    valorstaulell[0]-- ;
                    valorstaulell[1]-- ;
                    break;
                }
              var lloc="resolucio";
              $('div[id='+lloc+']').html("");
              escriupolinomi(lloc,valorstaulell);
              if ((pas==1) && (verificapasu(valorstaulell,valorssolucio))){
                $("#barrapas").html("Molt bé");
                actualitzabenfets(benfets,difficulty);
                missatgeresum(iniciats,benfets);
                //setTimeout(explode1, 500);
                //$("#barrapas").html("Molt bé");
              }
              }
            }
          } //fi drop
        }); // fi droppable
});

$("#acceptar").click(function(){
  valorsenunciat[4]=$("#iu").val();
  valorsenunciat[5]=$("#iun").val();
  valorsenunciat[2]=$("#ix").val();
  valorsenunciat[3]=$("#ixn").val();
  valorsenunciat[0]=$("#ixq").val();
  valorsenunciat[1]=$("#ixqn").val();
     
  solucio(valorsenunciat,valorssolucio);  
  /** mirem que no s'hagi introduït cap valor >3 o <-3 */
  
  if (!valorscorrectes(valorsenunciat)){
    alert("Els valors han de ser entre 0 i 3, hauràs de tornar a entrar els valors!");
    $("#entraexercici").popup("close"); 
  } else if (soniguals(valorsenunciat,valorssolucio)){
    alert("Polinomi ja està reduït, hauràs d'entrar un altre polinomi");
    $("#entraexercici").popup("close");
  } else {
    identifica_dificultat(valorsenunciat);
    difficulty=$("#select-dificultat").val();
    $("#enunciat").html("");
    var lloc="enunciat";
    $('div[id='+lloc+']').html("");
    escriupolinomi(lloc,valorsenunciat);
    $("#barrapas").html("Pas 1: Construeix el model");
    $("#resolucio").html("");
    $(".taulell").fadeOut();
     pas=0;
    valorstaulell=[0,0,0,0,0,0];
    var lloc="resolucio";
    escriupolinomi(lloc,valorstaulell);
    actualitzainiciats(iniciats,difficulty);  
    $("#entraexercici").popup("close");
  }
 });

/** clicant al botó +/- les rajoles canvien de signe */
 var s=0;
$( "#mesmenys" ).click(function() {
  if (s==0){
  $( "#udiv" ).animate({
  backgroundColor: "red",
  borderBottomColor: "#dc143c",
  borderLeftColor: "#dc143c",
  borderRightColor: "#dc143c",
  borderTopColor: "#dc143c"});
  $("#udiv").html("-1");
  $("#udiv").removeClass("positiva").addClass("negativa");
  $( "#xdiv" ).animate({
  backgroundColor: "red",
  borderBottomColor: "#dc143c",
  borderLeftColor: "#dc143c",
  borderRightColor: "#dc143c",
  borderTopColor: "#dc143c"});
  $("#xdiv").html("-x");
  $("#xdiv").removeClass("positiva").addClass("negativa");
  $( "#xqdiv" ).animate({
  backgroundColor: "red",
  borderBottomColor: "#dc143c",
  borderLeftColor: "#dc143c",
  borderRightColor: "#dc143c",
  borderTopColor: "#dc143c"});
  $("#xqdiv").html("-x"+'<sup><small>'+"2"+'</small></sup>');
  $("#xqdiv").removeClass("positiva").addClass("negativa");
  s=1;
} else {
  $( "#udiv" ).animate({
  backgroundColor: "yellow",
  borderBottomColor: "#ffd700",
  borderLeftColor: "#ffd700",
  borderRightColor: "#ffd700",
  borderTopColor: "#ffd700"});
  $("#udiv").html("1");
  $("#udiv").removeClass("negativa").addClass("positiva");
  $( "#xdiv" ).animate({
  backgroundColor: "#32cd32",
  borderBottomColor: "#228b22",
  borderLeftColor: "#228b22",
  borderRightColor: "#228b22",
  borderTopColor: "#228b22"});
  $("#xdiv").html("x");
  $("#xdiv").removeClass("negativa").addClass("positiva");
  $( "#xqdiv" ).animate({
  backgroundColor: "#0000cd",
  borderBottomColor: "#000080",
  borderLeftColor: "#000080",
  borderRightColor: "#000080",
  borderTopColor: "#000080"});
  $("#xqdiv").html("x"+'<sup><small>'+"2"+'</small></sup>');
  $("#xqdiv").removeClass("negativa").addClass("positiva");
  s=0;
}
});
}


/**------------MULTIPLICACIÓ__________________*/

/** Mètode que genera un nou exercici de multiplicació de la dificultat corresponent, 
 * l'atzar genera els coeficients dels dos factors, 
 * el nou exercici s'escriu a la barra d'enunciat,
 * a la barra de pas s'hi escriu pas 1
 *  @param valorsenunciatm: array amb els coeficients dels factors
 *  @param difficultym: dificultat de l'exercici (alta, mitjana, baixa)
 *  @return valorssoluciom: array amb els coeficients del polinomi solució
 *  @return pasm: s'actualitza a pas 1
 */
function nouexercicim(valorsenunciatm,valorssoluciom,difficultym){
  var rand=0;
  $(".factor1").fadeOut();
  $(".factor2").fadeOut();
  $(".sol").fadeOut();
  $("#droppable4").css({top:"163px",width:"5px",height:"5px"});
  $("#resolucio").html("");
    
  switch (difficultym) {
    case "alta":
       for (i=0;i<4;i++){
        do{
          rand = Math.floor((Math.random()*7)-3);
        } while (rand==0);
        valorsenunciatm[i]=rand;
       }
       break;
    case "mitjana":
        do{
          for (i=0;i<2;i++){
            rand = Math.floor((Math.random()*7-3));
            valorsenunciatm[i]=rand;
          }
        } while  ((valorsenunciatm[0]!=0 && valorsenunciatm[1]!=0)||
                 (valorsenunciatm[0]==0 && valorsenunciatm[1]==0));
        for (i=2;i<4;i++){
        do{
          rand = Math.floor((Math.random()*7)-3);
        } while (rand==0);
        valorsenunciatm[i]=rand;
       }
        break;
    case "baixa":
       do {
          for (i=0;i<2;i++){
          rand = Math.floor((Math.random()*7-3));
          valorsenunciatm[i]=rand;
          }
        } while ((valorsenunciatm[0]!=0 && valorsenunciatm[1]!=0)||
                 (valorsenunciatm[0]==0 && valorsenunciatm[1]==0));
       do {
          for (i=2;i<4;i++){
          rand = Math.floor((Math.random()*7-3));
          valorsenunciatm[i]=rand;
          }
        } while ((valorsenunciatm[2]!=0 && valorsenunciatm[3]!=0)||
                 (valorsenunciatm[2]==0 && valorsenunciatm[3]==0)); 
       break;
  }
  soluciom(valorsenunciatm, valorssoluciom);
  var factors=valorsenunciatm;
  var lloc="enunciat";
  escriufactors(lloc,factors,difficultym);
  $("#barrapas").html("Pas 1: Construeix el model, comença pels factors");
  
}

/** Mètode que calcula els coeficients del polinomi producte
 * @param valorsenunciatm: array amb coeficients factors
 * @param valorssoluciom: array amb coeficients producte
 */
function soluciom(valorsenunciatm, valorssoluciom){
  valorssoluciom[0]=valorsenunciatm[0]*valorsenunciatm[2];
  valorssoluciom[2]=valorsenunciatm[1]*valorsenunciatm[3];
  valorssoluciom[1]=valorsenunciatm[1]*valorsenunciatm[2]+valorsenunciatm[0]*valorsenunciatm[3];
} 

/**Mètode que escriu els factors a partir dels seus coeficients
 * @param lloc: div on s'han d'escriure els factors
 * @param factors: array amb coeficients factors
 * @param difficultym: dificultat de l'exercici
 */
function escriufactors(lloc,factors,difficultym){
  $('div[id='+lloc+']').html("");
  var tiles=['x','','x','']; 
  if (factors[1]>=0) tiles[1]='+';
  if (factors[3]>=0) tiles[3]='+';
  if (factors[0]==-1) tiles[0]="-x";
  if (factors[2]==-1) tiles[2]="-x"; 
  switch (difficultym) {
    case "alta": 
      if (factors[0]==1 || factors[0]==-1){
        $('div[id='+lloc+']').append('('+tiles[0]+tiles[1]+factors[1]);
      } else{
        $('div[id='+lloc+']').append('('+factors[0]+tiles[0]+tiles[1]+factors[1]);
      }
      if (factors[2]==1 || factors[2]==-1){
        $('div[id='+lloc+']').append(')('+tiles[2]+tiles[3]+factors[3]+')');
      }else{
        $('div[id='+lloc+']').append(')('+factors[2]+ tiles[2]+tiles[3]+factors[3]+')');
      }
      break;
    case "mitjana": 
      if (factors[0]==0){
        $('div[id='+lloc+']').append(factors[1]);
      }else if (factors[0]==1 || factors[0]==-1){
        $('div[id='+lloc+']').append(tiles[0]);
      }else {
        $('div[id='+lloc+']').append(factors[0]+ tiles[0]);
      }
      if (factors[2]==1 || factors[2]==-1){
        $('div[id='+lloc+']').append('('+tiles[2]+tiles[3]+factors[3]+')');
      }else{
        $('div[id='+lloc+']').append('('+factors[2]+ tiles[2]+tiles[3]+factors[3]+')');
      }
      break;
    case "baixa": 
      if (factors[0]==0){
        $('div[id='+lloc+']').append(factors[1]);
      }else if (factors[0]==1 ||factors[0]==-1){
        $('div[id='+lloc+']').append(tiles[0]);
      }else {
        $('div[id='+lloc+']').append(factors[0]+tiles[0]);
      }
      if(factors[2]<0){
        if (factors[2]==-1 || factors[2]==1){
          $('div[id='+lloc+']').append('('+tiles[2]+')');
        }else {
          $('div[id='+lloc+']').append('('+factors[2]+tiles[2]+')');
        }
      } 
      if(factors[2]>0){
        if (factors[2]==1){
          $('div[id='+lloc+']').append('·'+tiles[2]);
        }else{
          $('div[id='+lloc+']').append('·'+factors[2]+tiles[2]);
        }
      }
      if(factors[3]<0) $('div[id='+lloc+']').append('('+factors[3]+')');
      if(factors[3]>0) $('div[id='+lloc+']').append('·'+factors[3]); 
      break;
  }   
}

/** Mètode cridat quan és l'usuari que entra l'exercici a resoldre,
 * identifica la dificultat de l'exercici entrat i fa canviar l'opció de menú select, 
 * alta: binomi·binomi, mitjana: monomi·binomi,
 * baixa: monomi·monomi
 * @param valorsenunciat: array amb els coeficients dels factors
 */
function identifica_dificultatm(valorsenunciatm){
  if ((valorsenunciatm[0]!= 0)&& (valorsenunciatm[1]!= 0)
       &&(valorsenunciatm[2]!= 0)&& (valorsenunciatm[3]!= 0)){
    document.getElementById("select-dificultat").value="alta";
  }
  if ((valorsenunciatm[0] == 0|| valorsenunciatm[1] == 0)
       &&(valorsenunciatm[2]!= 0 && valorsenunciatm[3]!= 0)){
    document.getElementById("select-dificultat").value="mitjana";
  }
  if (((valorsenunciatm[0] == 0)|| (valorsenunciatm[1] == 0))
       &&((valorsenunciatm[2]== 0)|| (valorsenunciatm[3]== 0))){
    document.getElementById("select-dificultat").value="baixa";
  }
  $("#select-dificultat").selectmenu("refresh");
}

/** Funció que actualitza el div resolucio,
* en ell s'escriuen els factors entrats i les 
* demés rajoles del taulell
* @param lloc: div resol
* */
function actualitzaresolucio(valorsfactor1, valorsfactor2,valorssol){
  var lloc="resolucio";
  $("#resolucio").html("");
  $("#resolucio").append('(');
  escriupolinomi(lloc,valorsfactor1);
  $("#resolucio").append(') ');
  $("#resolucio").append('(');
  escriupolinomi(lloc,valorsfactor2);
  $("#resolucio").append(')');
    
  if (signeigual(valorsfactor1, valorsfactor2, valorssol)){
    $("#resolucio").append('=');
  } else{
    $("#resolucio").append('&ne;');  
  }
  escriupolinomi(lloc,valorssol);
}

/** Mètode que permetrà saber si al div resolució cal posar 
 * signe igual o el signe desigual entre l'enunciat i les rajoles del taulell
 * @param valorsfactor1: coeficients del factor1
 * @param valorsfactor2: coeficients del factor2
 * @param valorssol: coeficients de les rajoles del taulell
 */
function signeigual(valorsfactor1, valorsfactor2, valorssol){
  /** Hi ha dues possibilitats:
   * 1. que tinguem les rajoles producte al taulell sense reduir.
   * 2. que tinguem les rajoles producte al taulell ja reduïdes.
  */
  var factorsentrats=[0,0,0,0];
  var fentratssolucio=[0,0,0,0];
  factorsentrats[0]= valorsfactor1[2]-valorsfactor1[3];
  factorsentrats[1]= valorsfactor1[4]-valorsfactor1[5];
  factorsentrats[2]= valorsfactor2[2]-valorsfactor2[3];
  factorsentrats[3]= valorsfactor2[4]-valorsfactor2[5];
  /** el producte dels factors entrats és: */
  soluciom (factorsentrats,fentratssolucio);
  
  /**passem rajoles de taulell a array de 4 i no de 6 */
  var compara=[0,0,0,0]; 
  compara[0]=valorssol[0]-valorssol[1];
  compara[1]=valorssol[2]-valorssol[3];
  compara[2]=valorssol[4]-valorssol[5];
  
  if (soniguals(compara,fentratssolucio)){
    return true;
  }else{
    return false;
  }
}

/** Mètode que comprova si el pas 1 (en programació pas=0)s'ha completat,
 * per fer-ho mira si els valorsfactor1 i valorsfactor2
 * coincideixen amb l'enunciat
 * @param valorsenunciatm: coeficients dels factors
 * @param valorsfactor1: coeficients d'un factor
 * @param valorsfactor2: coeficients de l'altre factor
 * @return true en cas que el pas1 s'hagi completat i false en cas contrari
 */
function verificapaszerom(valorsenunciatm, valorsfactor1, valorsfactor2){
  /** degut a què usuari pot posar factor 1 o factor 2 indistintament en el taulell,
   * escrivim les dues possibilitats per comparar amb enunciat*/
  var possibilitat1 =[0,0,0,0];
  var possibilitat2 =[0,0,0,0];
  possibilitat1=[valorsfactor1[2]-valorsfactor1[3],valorsfactor1[4]-valorsfactor1[5],
                    valorsfactor2[2]-valorsfactor2[3],valorsfactor2[4]-valorsfactor2[5]];
  possibilitat2=[valorsfactor2[2]-valorsfactor2[3],valorsfactor2[4]-valorsfactor2[5],
                    valorsfactor1[2]-valorsfactor1[3],valorsfactor1[4]-valorsfactor1[5]];
  var pr1=0;
  var pr2=0;
  
  for (i=0;i<4;i++){
    if (valorsenunciatm[i] != possibilitat1[i]){
      pr1=1;
    }
  }
  for (i=0;i<4;i++){
    if (valorsenunciatm[i]!= possibilitat2[i]){
      pr2=1;
    }
  }
  if(pr1==0 || pr2==0){
    return true; 
  }else{
    return false;
  }
}

/** Mètode que comprova si el pas 2 (en programació pas=1)s'ha completat,
 * per fer-ho realitza el productes terme·terme sense 
 * reduir termes semblants
 * @param valorsenunciatm: coeficients dels factors
 * @param valorssol: coeficients del polinomi producte
 * @return true en cas que el pas1 s'hagi completat i false en cas contrari
 */
function verificapasum(valorsenunciatm,valorssol){
  /*passem valorsenunciatm als quatre productes*/
  var compara=[0,0,0,0,0,0];
  var terme_quadratic=valorsenunciatm[0]*valorsenunciatm[2];
  var terme_independent=valorsenunciatm[1]*valorsenunciatm[3];
  if (terme_quadratic>0){
    compara[0]=terme_quadratic;
    compara[1]=0;
  }else if(terme_quadratic<0){
    compara[1]=-terme_quadratic;
    compara[0]=0;
  } else{
    compara[0]=0;
    compara[0]=0;
  }
  if (terme_independent>0){
    compara[4]=terme_independent;
    compara[5]=0;
  }else if(terme_independent<0){
    compara[5]=-terme_independent;
    compara[4]=0;
  } else{
    compara[4]=0;
    compara[5]=0;
  }
  terme_linealu=valorsenunciatm[0]*valorsenunciatm[3];
  terme_lineald=valorsenunciatm[1]*valorsenunciatm[2];  
  if (terme_linealu>0 && terme_lineald<0){
    compara[2]=terme_linealu;
    compara[3]=-terme_lineald;
  }
  if (terme_linealu<0 && terme_lineald>0){
    compara[2]=terme_lineald;
    compara[3]=-terme_linealu;
  }
  if (terme_linealu>0 && terme_lineald>0){
    compara[2]=terme_linealu+terme_lineald;
    compara[3]=0;
  }
  if (terme_linealu<0 && terme_lineald<0){
    compara[3]=-terme_linealu-terme_lineald;
    compara[2]=0;
  }
  if (terme_linealu==0 && terme_lineald>0){
    compara[2]=terme_lineald;
    compara[3]=0;
  }
  if (terme_linealu==0 && terme_lineald<0){
    compara[3]=-terme_lineald;
    compara[2]=0;
  }
  if (terme_linealu>0 && terme_lineald==0){
    compara[2]=terme_linealu;
    compara[3]=0;
  }
  if (terme_linealu<0 && terme_lineald==0){
    compara[3]=-terme_linealu;
    compara[2]=0;
  }
  if (terme_linealu==0 && terme_lineald==0){
    compara[3]=0;
    compara[2]=0;
  }
  if (soniguals(compara,valorssol)){
    return true;
  } else{
    return false;
  }
}

/** Mètode que comprova si el pas 3 (en programació pas=2)s'ha completat,
 * per fer-ho mira si els valorssol coincideixen amb els valorsoluciom
 * @param valorssoluciom: coeficients del polinomi producte
 * @param valorssol: coeficients del polinomi del taulell
 * @return true en cas que el pas1 s'hagi completat i false en cas contrari
 */
function verificapasdosm(valorssoluciom,valorssol){
  var compara=[0,0,0,0,0,0]; 
  /*passem valorssoluciom a array de 6 */
  if (valorssoluciom[0]>0){
    compara[0]=valorssoluciom[0];
    compara[1]=0;
  } else if (valorssoluciom[0]<0){
    compara[1]=-valorssoluciom[0];
    compara[0]=0;  
  } else{
    compara[1]=0;
    compara[0]=0;  
  }
  if (valorssoluciom[1]>0){
    compara[2]=valorssoluciom[1];
    compara[3]=0;
  } else if (valorssoluciom[1]<0){
    compara[3]=-valorssoluciom[1];
    compara[2]=0;  
  } else{
    compara[2]=0;
    compara[3]=0;  
  }
  if (valorssoluciom[2]>0){
    compara[4]=valorssoluciom[2];
    compara[5]=0;
  } else if (valorssoluciom[2]<0){
    compara[5]=-valorssoluciom[2];
    compara[4]=0;  
  } else{
    compara[4]=0;
    compara[5]=0;  
  } 
  
  if (soniguals(compara, valorssol)){
    return true;
  }else{
    return false;
  }  
}
/** Mètode s'encarrega d'afegir al div resum, el resum de la feina feta,
 * ens informa de quants exercicis de cada dificultat s'han resolt correctament 
 * del total d'exercicis d'aquella dificultat iniciats
 *  @param iniciats: array que conté el nombre d'exercicis iniciats de cada dificultat
 *  @param benfets: array que conté el nombre d'exercicis completats de cada dificultat
 */
function missatgeresumm(iniciatsm,benfetsm){
  $("div[id='resum']").html("");
  $("div[id='resum']").append(benfetsm[0]+ " de "+iniciatsm[0]+" exercicis de binomi per binomi, <br>" +
                                  benfetsm[1]+ " de "+iniciatsm[1]+" exercicis de monomi per binomi, <br>"+

                                benfetsm[2]+ " de "+iniciatsm[2]+" exercicis de monomi per monomi. <br><br>"+
                                  "per seguir practicant tens tres opcions:<br>"+
                                  "- Clica a Nou i l'app et generarà un nou exercici de la mateixa dificultat.<br>"+
                                  "- Escull dificultat i l'app et generarà exercici de la dificultat escollida. <br>"+
                                  "- Clica Entra i podràs entrar tu mateix l'exercici.");                   
}

/** Mètode que conté tot el desenvolupament dinàmic de l'aplicació simplificar 
 */
function multiplicar(){
  var pasm=0;
  var valorsenunciatm=[0,0,0,0];
  var valorssoluciom=[0,0,0,0];
  var valorsfactor1=[0,0,0,0,0,0];
  var valorsfactor2=[0,0,0,0,0,0];
  var difficultym= $("#select-dificultat").val();
  var valorssol=[0,0,0,0,0,0];
  var benfetsm=[0,0,0];
  var iniciatsm=[0,0,0];
  
$("#enunciat").html("");
$("#resolucio").html("");
  
$("#comencem").popup("open"); 

/** tancament dels popups informatius */
$("#acord").click(function(){
  $("#comencem").popup("close"); 
});

$("#acord1").click(function(){
  $("#nocomencem").popup("close"); 
});
$("#entesos1").click(function(){
$("#fipas1").popup("close");
});

$("#entesos2").click(function(){
$("#fipas2").popup("close");
});

$("#numero_correcteacord").click(function(){
$("#numero_correcte").popup("close");
});

$("#reiniciaacord").click(function(){
$("#reinicia").popup("close");
});

var r=0;
$("#xdiv").on("taphold",function(){
  if (r==0) {
    $(this).css({transform:"rotate(-90deg)"});
    r=1;
  }else{
    $(this).css({transform:"rotate(0deg)"});
    r=0;
  }
});

/** fem que les rajoles de div stock es puguin arrossegar */
$( ".stock" ).draggable({
  helper: "clone",
  stop:function(ev, ui) {
    $(this).draggable('option','revert','invalid');
    }                
});

/** fem que el droppable1 (factor1) accepti rajoles de div stock o bé del mateix div taulell,
 *no pot acceptar rajoles de x^2 o -x^2
 */
$("#droppable1" ).droppable({
  accept: ".stock:not(.quadrat)" || ".factor2 ",
  tolerance:"fit",
  drop: function (event, ui) {
    var id = ui.draggable.attr("id");
    var p=138-valorsfactor1[2]*44-valorsfactor1[3]*44-valorsfactor1[4]*24-valorsfactor1[5]*24;
    var pp=146-valorsfactor1[2]*44-valorsfactor1[3]*44-valorsfactor1[4]*24-valorsfactor1[5]*24;
    if (id=="xdiv") ui.draggable.clone().appendTo(this).css({position:"absolute",left:"-4px",top:p,transform:"rotate(-90deg)"}).removeClass("stock").addClass("factor1").draggable() ;
    if (id=="udiv") ui.draggable.clone().appendTo(this).css({position:"absolute",left:"6px",top:pp}).removeClass("stock").addClass("factor1").draggable() ;
    $(".factor1").draggable("option","containment","#droppp");
                      
  /** fem que cada cop que arrosseguem una rajola al taulell s'actualitzin 
    * comptadors de rajoles*/
  
  switch (id){
    case "xdiv":
      if (ui.draggable.hasClass("positiva")){
        valorsfactor1[2]++ ;
        } else {
        valorsfactor1[3]++ ; 
      }
    break;
    case "udiv":
      if (ui.draggable.hasClass("positiva")){
        valorsfactor1[4]++ ;
        } else {
        valorsfactor1[5]++;
        } 
    break;
  }
  var h=valorsfactor1[2]*44+valorsfactor1[3]*44+valorsfactor1[4]*24+valorsfactor1[5]*24;
  var hh=166-valorsfactor1[2]*44-valorsfactor1[3]*44-valorsfactor1[4]*24-valorsfactor1[5]*24;
  $("#droppable4").css({top:hh,height:h});
  
  /** cal actualitzar div resolucio que és on s'escriuen factors del taulell */
  actualitzaresolucio(valorsfactor1, valorsfactor2, valorssol);
    /**si s'ha completat correctament pas 1, un popup ens ho dirà i passarem al 2,
   en la programació pasm=1 */
  if ((pasm==0) && (verificapaszerom(valorsenunciatm, valorsfactor1, valorsfactor2))){
      $("#fipas1").popup("open");
      $("#barrapas").html("Pas 2: Representa la solució amb rajoles");
     pasm=pasm+1;
}    
} // drop droppable1
}); //droppable1 

/** fem que el droppable2 (factor2) accepti rajoles de div stock,
 *no pot acceptar rajoles de x^2 o -x^2
 */
$("#droppable2" ).droppable({
  accept: ".stock:not(.quadrat)" || ".factor1 ",
  tolerance:"fit",
  drop: function (event, ui) {
    var id = ui.draggable.attr("id");
    ui.draggable.clone().appendTo(this).css({ position: "relative", float:"left"}).removeClass("stock factor1").addClass("factor2").draggable() ;
    
    $(".factor2").draggable("option","containment","#droppp");
                   
  /** fem que cada cop que arrosseguem una rajola al div del factor s'actualitzin 
    * valorsfactor2 de rajoles*/
  
  switch (id){
    case "xdiv":
      if (ui.draggable.hasClass("positiva")){
        valorsfactor2[2]++  ;
        } else {
        valorsfactor2[3]++ ; 
      }
    break;
    case "udiv":
      if (ui.draggable.hasClass("positiva")){
        valorsfactor2[4]++ ;
        } else {
        valorsfactor2[5]++ ;
        } 
    break;
  }
  var w=valorsfactor2[2]*44+valorsfactor2[3]*44+valorsfactor2[4]*24+valorsfactor2[5]*24;
  $("#droppable4").css({width:w});
  /** cal actualitzar div resolucio que és on s'escriuen factors del taulell */

  actualitzaresolucio(valorsfactor1, valorsfactor2, valorssol);
  
  /**si s'ha completat correctament pas 1, un popup ens ho dirà i passarem al 2,
   en la programació pasm=1 */
 if ((pasm==0) && (verificapaszerom(valorsenunciatm, valorsfactor1, valorsfactor2))){
      $("#fipas1").popup("open");
      $("#barrapas").html("Pas 2: Representa la solució amb rajoles");
     pasm=pasm+1;
}  
} // fi drop del droppable2
}); // fi droppable2


/** fem que el taulell accepti rajoles de div stock o bé del mateix div taulell */
  $( "#droppable3" ).droppable({
    accept: ".stock" || ".factor1" || ".factor2",
    tolerance:"fit",
    drop: function (event, ui) {
      ui.draggable.clone().appendTo(this).css({ position: "absolute", top: ui.position.top, left: ui.position.left }).removeClass("stock").addClass("sol").draggable() ;
           
      $(".sol").draggable("option","containment","#droppp");
    /**fem que cada cop que arrosseguem una rajola al taulell s'actualitzin 
       * valorssol de rajoles*/
       var id = ui.draggable.attr("id");
        switch (id){
          case "xqdiv":
            if (ui.draggable.hasClass("positiva")){
              valorssol[0]++ ;
              } else{
              valorssol[1]++ ;
              }
            break;
          case "xdiv":
            if (ui.draggable.hasClass("positiva")){
              valorssol[2]++ ;
              } else {
              valorssol[3]++ ;
              }
            break;
          case "udiv":
            if (ui.draggable.hasClass("positiva")){
               valorssol[4]++ ;
               } else {
               valorssol[5]++ ;
               } 

            break;
        }//switch
        /** cal actualitzar div resolucio que és on s'escriu polinomi representat al taulell */
        actualitzaresolucio(valorsfactor1, valorsfactor2, valorssol);
        if ((pasm==1) && (verificapasum(valorsenunciatm,valorssol))) {
          if (verificapasdosm(valorssoluciom, valorssol)){
            actualitzabenfets(benfetsm,difficultym);
            $("#fipas2").popup("open");
            missatgeresumm(iniciatsm,benfetsm);
            $("#barrapas").html("Molt bé!");
        }else{
            $("#fipas1").popup("open");
            $("#barrapas").html("Pas 3: Redueix termes semblants");
            pasm++;
         }   
        }
        if ((pasm==2) && verificapasdosm(valorssoluciom,valorssol)) {
          actualitzabenfets(benfetsm,difficultym);
          $("#fipas2").popup("open");
          missatgeresumm(iniciatsm,benfetsm);
          $("#barrapas").html("Molt bé!");
        }  
     /**fem que rajoles del taulell també siguin droppable, per poder eliminar
          * parelles zero, valorssol corresponents seran actualitzats  */
        $(".sol").droppable({
          accept: ".sol",
          drop: function (event, ui) {
            var iddivdra = ui.draggable.attr("id");
            var iddivdro = $(this).attr("id");
            if (iddivdra==iddivdro){
              if (($(this).hasClass("negativa") && ui.draggable.hasClass("positiva")) || ($(this).hasClass("positiva") && ui.draggable.hasClass("negativa"))){
                $(this).fadeOut();
                ui.draggable.fadeOut();
                switch (iddivdra){
                  case "udiv":
                    valorssol[4]-- ;
                    valorssol[5]-- ;
                    break;
                  case "xdiv":
                    valorssol[2]-- ;
                    valorssol[3]-- ;
                    break;          
                  case "xqdiv":
                    valorssol[0]-- ;
                    valorssol[1]-- ;
                    break;
                }
            }

          }
          /** actualitzem div resolucio */
      actualitzaresolucio(valorsfactor1, valorsfactor2, valorssol);
            /**posarem verificació pas 2*/
            /**si s'ha completat correctament pas 1, un popup ens ho dirà i passarem al 2,
              en la programació pasm=1 */
        if ((pasm==1) && (verificapasum(valorsenunciatm,valorssol))) {
          if (verificapasdosm(valorssoluciom, valorssol)){
            actualitzabenfets(benfetsm,difficultym);
            $("#fipas2").popup("open");
            missatgeresumm(iniciatsm,benfetsm);
            $("#barrapas").html("Molt bé!");
        }else{
            $("#fipas1").popup("open");
            $("#barrapas").html("Pas 3: Redueix termes semblants");
            pasm++;
         }   
        }

        if ((pasm==2) && verificapasdosm(valorssoluciom,valorssol)) {
          actualitzabenfets(benfetsm,difficultym);
          $("#fipas2").popup("open");
          missatgeresumm(iniciatsm,benfetsm);
          $("#barrapas").html("Molt bé!");
        }  
          } // fi drop .sol
          }); //fi droppable .sol */
    } //drop droppable3
});            

/** fem que el div que conté la paperera sigui droppable
   * quan s'hi arrosseguin rajoles s'acualitzaren comptadors del taulell */
$("#prova").droppable({
    accept: ".sol" || ".factor1" || ".factor2",
    over: function(){
      $("#tapa").animate({
        top: "-=10"}).animate({
        top:"+=10"});
      },
    drop: function (event,ui){
      var iddra = ui.draggable.attr("id");
      ui.draggable.fadeOut();
      switch (iddra){
        case "udiv":
          if (ui.draggable.hasClass("factor1")&& ui.draggable.hasClass("positiva"))
              valorsfactor1[4]--;
          if (ui.draggable.hasClass("factor1")&& ui.draggable.hasClass("negativa"))
              valorsfactor1[5]--;
          if (ui.draggable.hasClass("factor2")&& ui.draggable.hasClass("positiva"))
              valorsfactor2[4]--;
          if (ui.draggable.hasClass("factor2")&& ui.draggable.hasClass("negativa"))
              valorsfactor2[5]--;
          if (ui.draggable.hasClass("sol")&& ui.draggable.hasClass("positiva"))
              valorssol[4]--;
          if (ui.draggable.hasClass("sol")&& ui.draggable.hasClass("negativa"))
              valorssol[5]--;
          break;
        case "xdiv":
          if (ui.draggable.hasClass("factor1")&& ui.draggable.hasClass("positiva"))
              valorsfactor1[2]--;
             if (ui.draggable.hasClass("factor1")&& ui.draggable.hasClass("negativa"))
              valorsfactor1[3]--;
          if (ui.draggable.hasClass("factor2")&& ui.draggable.hasClass("positiva"))
              valorsfactor2[2]--;
          if (ui.draggable.hasClass("factor2")&& ui.draggable.hasClass("negativa"))
              valorsfactor2[3]--;
          if (ui.draggable.hasClass("sol")&& ui.draggable.hasClass("positiva"))
              valorssol[2]--;
          if (ui.draggable.hasClass("sol")&& ui.draggable.hasClass("negativa"))
              valorssol[3]--;
          break;
        case "xqdiv":
          if (ui.draggable.hasClass("sol")&& ui.draggable.hasClass("positiva"))
              valorssol[0]--;
          if (ui.draggable.hasClass("sol")&& ui.draggable.hasClass("negativa"))
              valorssol[1]--;
          break;
      }                                      
      /** també cal actualitzar div resolucio i verificar si tenim ja la solució */
      actualitzaresolucio(valorsfactor1, valorsfactor2, valorssol,valorsenunciatm);     
      /**si s'ha completat correctament pas 1, un popup ens ho dirà i passarem al 2,
      en la programació pasm=1 */
      if ((pasm==1) && (verificapasum(valorsenunciatm,valorssol))) {
          if (verificapasdosm(valorssoluciom, valorssol)){
            actualitzabenfets(benfetsm,difficultym);
            $("#fipas2").popup("open");
            missatgeresumm(iniciatsm,benfetsm);
            $("#barrapas").html("Molt bé!");
        }else{
            $("#fipas1").popup("open");
            $("#barrapas").html("Pas 3: Redueix termes semblants");
            pasm++;
         }   
        } 
    /**si s'ha completat correctament pas 2, un popup ens ho dirà i passarem al 3,
   en la programació pasm=2 */
    if ((pasm==2) && verificapasdosm(valorssoluciom,valorssol)) {
          actualitzabenfets(benfetsm,difficultym);
          $("#fipas2").popup("open");
          missatgeresumm(iniciatsm,benfetsm);
          $("#barrapas").html("Molt bé!");
        } 
     } //drop
}); //fi droppable prova

/** cada vegada que usuari canviï la dificultat es generarà un nou exercici d'aquella dificultat */
$("#select-dificultat").change(function(event){
    difficultym = $(this).val();
    $(".factor1").fadeOut();
    $(".factor2").fadeOut();
    $(".sol").fadeOut();
    $("#resolucio").html("");
    valorsenunciatm=[0,0,0,0];
    valorssoluciom=[0,0,0,0];
    valorsfactor1=[0,0,0,0,0,0];
    valorsfactor2=[0,0,0,0,0,0];
    valorssol=[0,0,0,0,0,0];
    pasm=0;
    nouexercicim(valorsenunciatm,valorssoluciom,difficultym);
    actualitzainiciats(iniciatsm,difficultym); 
});

/** quan es cliqui Nou, es generarà un nou exercici de la dificultat que estigui seleccionada,
 * s'actualizarà el comptador d'exercicis iniciats */
$("#nouexercici").click(function(){
  if (difficultym=="") {
    $("#nocomencem").popup("open");
  } else {
    valorsenunciatm=[0,0,0,0];
    valorssoluciom=[0,0,0,0];
    valorsfactor1=[0,0,0,0,0,0];
    valorsfactor2=[0,0,0,0,0,0];
    valorssol=[0,0,0,0,0,0];
    pasm=0;
    nouexercicim(valorsenunciatm,valorssoluciom,difficultym);
    actualitzainiciats(iniciatsm,difficultym); 
  }
});

/**els valors entrats per l'usuari en Entrar un exercici queden emmagatzemats com 
 * a valorsenunciat sempre i quan el producte no sigui zero o bé 
 * no estiguin entre 3 i -3
 * tot queda actualitzat  */
$("#acceptarm").click(function(){
  if ($("#f1x").val()==""){
   valorsenunciatm[0]=0;
  }else{
    valorsenunciatm[0]=parseInt($("#f1x").val());
  }
  if ($("#f1n").val()==""){
    valorsenunciatm[1]=0;
  }else{
    valorsenunciatm[1]=parseInt($("#f1n").val());
  }
  if ($("#f2x").val()==""){
    valorsenunciatm[2]=0;
  }else{
    valorsenunciatm[2]=parseInt($("#f2x").val());
  }
  if ($("#f2n").val()==""){
    valorsenunciatm[3]=0;
  }else{
    valorsenunciatm[3]=parseInt($("#f2n").val());
  }
  
  /** mirem que no s'hagi introduït cap factor 0 */
  if ((valorsenunciatm[0]==0 && valorsenunciatm[1]==0
    && valorsenunciatm[2]==0 && valorsenunciatm[3]==0)
    ||((valorsenunciatm[0]==0 && valorsenunciatm[1]==0)
    || (valorsenunciatm[2]==0 && valorsenunciatm[3]==0))){
  alert("Resulat 0, un dels factors o tots dos són zero, hauràs d'entrar uns nous factors");
  $("#entraexercici").popup("close"); 
  }

   /** mirem que no s'hagi introduït cap valor >3 o <-3 */
  if (!valorscorrectes(valorsenunciatm)){
     alert("Els valors han de ser entre -3 i 3, hauràs d'entrar uns nous factors");
     $("#entraexercici").popup("close"); 
  }
  
  if ((valorsenunciatm[0] != 0 && valorsenunciatm[1] != 0)
       &&(valorsenunciatm[2] == 0 || valorsenunciatm[3] == 0)){
    if ($("#f2x").val()==""){
      valorsenunciatm[0]=0;
    }else{
      valorsenunciatm[0]=parseInt($("#f2x").val());
    }
    if ($("#f2n").val()==""){
      valorsenunciatm[1]=0;
    }else{
      valorsenunciatm[1]=parseInt($("#f2n").val());
    }
    valorsenunciatm[2]=parseInt($("#f1x").val());
    valorsenunciatm[3]=parseInt($("#f1n").val());
  }
  valorssoluciom=[0,0,0,0];
  soluciom(valorsenunciatm,valorssoluciom);  
  identifica_dificultatm(valorsenunciatm);
  difficultym=$("#select-dificultat").val();
  $("#enunciat").html("");
  var factors=valorsenunciatm;
  var lloc="enunciat";
  escriufactors(lloc,factors,difficultym);
  $("#barrapas").html("Pas 1: Construeix el model, comença pels factors");
  $("#resolucio").html("");
  pasm=0;
  valorsfactor1=[0,0,0,0,0,0];
  valorsfactor2=[0,0,0,0,0,0];
  valorssol=[0,0,0,0,0,0];
  $(".factor1").fadeOut();
  $(".factor2").fadeOut();
  $(".sol").fadeOut();
  $("#droppable4").css({top:"163px",width:"5px",height:"5px"});
  actualitzainiciats(iniciatsm,difficultym);  
  $("#entraexercici").popup("close");
 });

/**quan es cliqui Esborrar, totes les rajoles del taulell, factor1, factor2, s'esborraran
  * s'actualitzarà la barra de resolució 
  **/ 
 $( "#esborrarm" ).click(function(){
  $(".factor1").fadeOut();
  $(".factor2").fadeOut();
  $(".sol").fadeOut();
  $("#droppable4").css({top:"163px",width:"5px",height:"5px"})
  $("#resolucio").html("");
  pasm=0;
  valorsfactor1=[0,0,0,0,0,0];
  valorsfactor2=[0,0,0,0,0,0];
  valorstaula=[0,0,0,0,0,0];
  valorssol=[0,0,0,0,0,0];
  $("#barrapas").html("Pas 1: Construeix el model, comença pels factors");
});

  /** clicant al botó +/- les rajoles canvien de signe */
 var sm=0;
$( "#mesmenys" ).click(function() {
  if (sm==0){
  $( "#udiv" ).animate({
  backgroundColor: "red",
  borderBottomColor: "#dc143c",
  borderLeftColor: "#dc143c",
  borderRightColor: "#dc143c",
  borderTopColor: "#dc143c"});
  $("#udiv").html("-1");
  $("#udiv").removeClass("positiva").addClass("negativa");
  $( "#xdiv" ).animate({
  backgroundColor: "red",
  borderBottomColor: "#dc143c",
  borderLeftColor: "#dc143c",
  borderRightColor: "#dc143c",
  borderTopColor: "#dc143c"});
  $("#xdiv").html("-x");
  $("#xdiv").removeClass("positiva").addClass("negativa");
  $( "#xqdiv" ).animate({
  backgroundColor: "red",
  borderBottomColor: "#dc143c",
  borderLeftColor: "#dc143c",
  borderRightColor: "#dc143c",
  borderTopColor: "#dc143c"});
  $("#xqdiv").html("-x"+'<sup><small>'+"2"+'</small></sup>');
  $("#xqdiv").removeClass("positiva").addClass("negativa");
  sm=1;
} else {
  $( "#udiv" ).animate({
  backgroundColor: "yellow",
  borderBottomColor: "#ffd700",
  borderLeftColor: "#ffd700",
  borderRightColor: "#ffd700",
  borderTopColor: "#ffd700"});
  $("#udiv").html("1");
  $("#udiv").removeClass("negativa").addClass("positiva");
  $( "#xdiv" ).animate({
  backgroundColor: "#32cd32",
  borderBottomColor: "#228b22",
  borderLeftColor: "#228b22",
  borderRightColor: "#228b22",
  borderTopColor: "#228b22"});
  $("#xdiv").html("x");
  $("#xdiv").removeClass("negativa").addClass("positiva");
  $( "#xqdiv" ).animate({
  backgroundColor: "#0000cd",
  borderBottomColor: "#000080",
  borderLeftColor: "#000080",
  borderRightColor: "#000080",
  borderTopColor: "#000080"});
  $("#xqdiv").html("x"+'<sup><small>'+"2"+'</small></sup>');
  $("#xqdiv").removeClass("negativa").addClass("positiva");
  sm=0;
}
});




}

